︠5c410e99-68dc-4f5d-9c19-ad0c153235f5i︠
%md
On Sat, Dec 3, 2016 at 10:53 PM, Ralf Stephan <> wrote:
> "Both ZZ and numpy use libgmp internally "

No, ZZ uses libgmp (actually really MPIR, which is a fork of GMP), and numpy uses Python's ints/longs.
Python's int/long type is arbitrary precision, despite the confusing naming.  It only implements relatively
naive algorithms -- karatsuba, etc., -- and not the asymptotically fast Fourier transform methods
that GMP (and MPIR) implement and highly optimize.  So Sage's ZZ will start beating the pants off of
Python (and numpy) when the numbers get large.

Example -- try this with various values of "digits" and you'll see ZZ being **arbitrarily faster** than Python's longs:
︡4ffad5e0-3882-46b5-8f94-04d9e8f42144︡{"done":true,"md":"On Sat, Dec 3, 2016 at 10:53 PM, Ralf Stephan <> wrote:\n> \"Both ZZ and numpy use libgmp internally \"\n\nNo, ZZ uses libgmp (actually really MPIR, which is a fork of GMP), and numpy uses Python's ints/longs.\nPython's int/long type is arbitrary precision, despite the confusing naming.  It only implements relatively\nnaive algorithms -- karatsuba, etc., -- and not the asymptotically fast Fourier transform methods\nthat GMP (and MPIR) implement and highly optimize.  So Sage's ZZ will start beating the pants off of\nPython (and numpy) when the numbers get large.\n\nExample -- try this with various values of \"digits\" and you'll see ZZ being **arbitrarily faster** than Python's longs:"}
︠fbad626c-fcbf-47d7-99e7-52c5176af3b9s︠
def bench(digits):
    print "digits =", digits
    global n, m, n1, m1, n2, m2  # timeit uses global namespace
    n = ZZ.random_element(10^digits)
    m = ZZ.random_element(10^digits)
    %timeit n*m
    n1 = int(n)
    m1 = int(m)
    %timeit n1*m1
    import numpy
    n2 = numpy.int(n)
    m2 = numpy.int(m)
    %timeit n2*m2
︡91186389-134e-49d0-86c2-945c97bf356c︡{"done":true}︡
︠12ccb958-7cb8-4198-a856-4c0cc7a48e27s︠
bench(10)
bench(100)
bench(1000)
bench(10000)
bench(100000)
bench(1000000)
︡caf63309-e4ad-4976-adb2-757f3bf2ea9a︡{"stdout":"digits = 10\n625 loops, best of 3: 51.1 ns per loop\n625 loops, best of 3: 126 ns per loop\n625 loops, best of 3: 107 ns per loop\n"}︡{"stdout":"digits = 100\n625 loops, best of 3: 445 ns per loop\n625 loops, best of 3: 315 ns per loop\n625 loops, best of 3: 254 ns per loop\n"}︡{"stdout":"digits = 1000\n625 loops, best of 3: 2.16 µs per loop\n625 loops, best of 3: 13.8 µs per loop\n625 loops, best of 3: 13.5 µs per loop\n"}︡{"stdout":"digits = 10000\n625 loops, best of 3: 64.9 µs per loop"}︡{"stdout":"\n625 loops, best of 3: 588 µs per loop"}︡{"stdout":"\n625 loops, best of 3: 618 µs per loop"}︡{"stdout":"\n"}︡{"stdout":"digits = 100000\n625 loops, best of 3: 1.47 ms per loop"}︡{"stdout":"\n25 loops, best of 3: 20.9 ms per loop"}︡{"stdout":"\n25 loops, best of 3: 21.9 ms per loop"}︡{"stdout":"\n"}︡{"stdout":"digits = 1000000\n25 loops, best of 3: 18.7 ms per loop"}︡{"stdout":"\n5 loops, best of 3: 870 ms per loop"}︡{"stdout":"\n5 loops, best of 3: 883 ms per loop"}︡{"stdout":"\n"}︡{"done":true}︡
︠8f662ab4-3db0-442c-bdbd-01bc163a8a8cs︠
# At 1 million digits (on this test machine): ZZ is 46.5 times faster than Python ints:
870 / 18.7
︡00ef1fd4-5001-4510-bf70-2716d5bc1e7b︡{"stdout":"46.5240641711230\n"}︡{"done":true}︡
︠507f98e8-9b2d-4fb5-98cf-857138d09d09︠









